diff --git a/pki/base/common/src/com/netscape/cmscore/request/ARequestRecord.java b/pki/base/common/src/com/netscape/cmscore/request/ARequestRecord.java
index 002ffd7b37b962c3fb77540146aebe15c69f13bc..e23d4007cbd573bfbb451a2890897f6c4ebadb69 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/ARequestRecord.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/ARequestRecord.java
@@ -38,5 +38,5 @@ class ARequestRecord {
     String mSourceId;
     String mOwner;
     String mRequestType;
-    Hashtable mExtData;
+    Hashtable<String, Object> mExtData;
 };
diff --git a/pki/base/common/src/com/netscape/cmscore/request/RequestQueue.java b/pki/base/common/src/com/netscape/cmscore/request/RequestQueue.java
index b1b4fb04ff3687e685ee667d048a6d823327f0bd..e78ff0daf3f8d11affd97576ee32b62b1a04c1ed 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/RequestQueue.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/RequestQueue.java
@@ -20,6 +20,7 @@ package com.netscape.cmscore.request;
 import java.math.BigInteger;
 import java.util.Date;
 import java.util.Enumeration;
+import java.util.Hashtable;
 
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
@@ -329,7 +330,6 @@ public class RequestQueue
 
         // Need only the requestid in the result of the search
         // TODO: generic search returning RequestId
-        String attrs[] = { IRequestRecord.ATTR_REQUEST_ID };
         String filter = "(" + IRequestRecord.ATTR_SOURCE_ID + "=" + id + ")";
 
         try {
@@ -357,7 +357,6 @@ public class RequestQueue
     protected Enumeration getRawList() {
         IDBSearchResults results = null;
         IDBSSession dbs = null;
-        String attrs[] = { IRequestRecord.ATTR_REQUEST_ID };
 
         try {
             dbs = mDB.createSession();
@@ -385,7 +384,6 @@ public class RequestQueue
     public IRequestList listRequestsByFilter(String f) {
         IDBSearchResults results = null;
         IDBSSession dbs = null;
-        String attrs[] = { IRequestRecord.ATTR_REQUEST_ID };
 
         try {
             dbs = mDB.createSession();
@@ -413,7 +411,6 @@ public class RequestQueue
     public IRequestList listRequestsByFilter(String f, int maxSize) {
         IDBSearchResults results = null;
         IDBSSession dbs = null;
-        String attrs[] = { IRequestRecord.ATTR_REQUEST_ID };
 
         try {
             dbs = mDB.createSession();
@@ -441,7 +438,6 @@ public class RequestQueue
     public IRequestList listRequestsByFilter(String f, int maxSize, int timeLimit) {
         IDBSearchResults results = null;
         IDBSSession dbs = null;
-        String attrs[] = { IRequestRecord.ATTR_REQUEST_ID };
 
         try {
             dbs = mDB.createSession();
@@ -467,7 +463,6 @@ public class RequestQueue
     public IRequestList listRequestsByStatus(RequestStatus s) {
         IDBSearchResults results = null;
         IDBSSession dbs = null;
-        String attrs[] = { IRequestRecord.ATTR_REQUEST_ID };
 
         try {
             String f1;
@@ -588,12 +583,12 @@ public class RequestQueue
     /*
      * list record attributes (debugging output)
      */
-    static void listRecordAttrs(String s, java.util.Hashtable h) {
+    static void listRecordAttrs(String s, Hashtable<String, Object> h) {
         System.err.println(s);
-        java.util.Enumeration e = h.keys();
+        Enumeration<String> e = h.keys();
 
         while (e.hasMoreElements()) {
-            String name = (String) e.nextElement();
+            String name = e.nextElement();
 
             System.err.println("Attr: " + name + " Value: " + h.get(name));
         }
diff --git a/pki/base/common/src/com/netscape/cmscore/request/RequestRecord.java b/pki/base/common/src/com/netscape/cmscore/request/RequestRecord.java
index 4c25d68136764ae6c88ba7a74b8e53ca31d9d49b..1d066f0ada3243d5746d83a4b63a0871f56e28eb 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/RequestRecord.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/RequestRecord.java
@@ -69,7 +69,7 @@ public class RequestRecord
         return mRequestId;
     }
 
-    public Enumeration getAttrNames() {
+    public Enumeration<String> getAttrNames() {
         return mAttrTable.keys();
     }
 
@@ -92,7 +92,7 @@ public class RequestRecord
         else if (name.equals(IRequestRecord.ATTR_EXT_DATA))
             return mExtData;
         else {
-            RequestAttr ra = (RequestAttr) mAttrTable.get(name);
+            RequestAttr ra = mAttrTable.get(name);
 
             if (ra != null)
                 return ra.get(this);
@@ -119,9 +119,9 @@ public class RequestRecord
         else if (name.equals(IRequestRecord.ATTR_REQUEST_OWNER))
             mOwner = (String) o;
         else if (name.equals(IRequestRecord.ATTR_EXT_DATA))
-            mExtData = (Hashtable) o;
+            mExtData = (Hashtable<String, Object>) o;
         else {
-            RequestAttr ra = (RequestAttr) mAttrTable.get(name);
+            RequestAttr ra = mAttrTable.get(name);
 
             if (ra != null)
                 ra.set(this, o);
@@ -135,12 +135,12 @@ public class RequestRecord
     }
 
     // IDBObj.getElements
-    public Enumeration getElements() {
+    public Enumeration<String> getElements() {
         return mAttrs.elements();
     }
 
     // IDBObj.getSerializableAttrNames
-    public Enumeration getSerializableAttrNames() {
+    public Enumeration<String> getSerializableAttrNames() {
         return mAttrs.elements();
     }
 
@@ -226,12 +226,12 @@ public class RequestRecord
     protected static final String mOC[] =
         { Schema.LDAP_OC_TOP, Schema.LDAP_OC_REQUEST, Schema.LDAP_OC_EXTENSIBLE };
 
-    protected static Hashtable loadExtDataFromRequest(IRequest r) throws EBaseException {
-        Hashtable h = new Hashtable();
+    protected static Hashtable<String, Object> loadExtDataFromRequest(IRequest r) throws EBaseException {
+        Hashtable<String, Object> h = new Hashtable<String, Object>();
 
-        Enumeration e = r.getExtDataKeys();
+        Enumeration<String> e = r.getExtDataKeys();
         while (e.hasMoreElements()) {
-            String key = (String) e.nextElement();
+            String key = e.nextElement();
             if (r.isSimpleExtDataValue(key)) {
                 h.put(key, r.getExtDataInString(key));
             } else {
@@ -242,10 +242,11 @@ public class RequestRecord
         return h;
     }
 
+    @SuppressWarnings("unchecked")
     protected void storeExtDataIntoRequest(IRequest r) throws EBaseException {
-        Enumeration e = mExtData.keys();
+        Enumeration<String> e = mExtData.keys();
         while (e.hasMoreElements()) {
-            String key = (String) e.nextElement();
+            String key = e.nextElement();
             Object value = mExtData.get(key);
             if (value instanceof String) {
                 r.setExtData(key, (String) value);
@@ -258,9 +259,9 @@ public class RequestRecord
         }
     }
 
-    protected static Vector mAttrs = new Vector();
+    protected static Vector<String> mAttrs = new Vector<String>();
 
-    static Hashtable mAttrTable = new Hashtable();
+    static Hashtable<String, RequestAttr> mAttrTable = new Hashtable<String, RequestAttr>();
 
     /*
      * This table contains attribute handlers for attributes
@@ -330,7 +331,7 @@ class RequestStateMapper
 
     //
     //
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return mAttrs.elements();
     }
 
@@ -360,7 +361,7 @@ class RequestStateMapper
         return Schema.LDAP_ATTR_REQUEST_STATE + op + value;
     }
 
-    protected final static Vector mAttrs = new Vector();
+    protected final static Vector<String> mAttrs = new Vector<String>();
 
     static {
         mAttrs.add(Schema.LDAP_ATTR_REQUEST_STATE);
@@ -381,7 +382,7 @@ class RequestIdMapper
 
     //
     //
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return mAttrs.elements();
     }
 
@@ -420,7 +421,7 @@ class RequestIdMapper
         return Schema.LDAP_ATTR_REQUEST_ID + op + v;
     }
 
-    protected final static Vector mAttrs = new Vector();
+    protected final static Vector<String> mAttrs = new Vector<String>();
 
     static {
         mAttrs.add(Schema.LDAP_ATTR_REQUEST_ID);
@@ -443,15 +444,16 @@ class RequestAttrsMapper
 
     //
     //
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return mAttrs.elements();
     }
 
     //
     public void mapObjectToLDAPAttributeSet(IDBObj parent,
             String name, Object obj, LDAPAttributeSet attrs) {
-        Hashtable ht = (Hashtable) obj;
-        Enumeration e = ht.keys();
+        @SuppressWarnings("unchecked")
+        Hashtable<String, Object> ht = (Hashtable<String, Object>) obj;
+        Enumeration<String> e = ht.keys();
 
         try {
             ByteArrayOutputStream bos = new ByteArrayOutputStream();
@@ -461,7 +463,7 @@ class RequestAttrsMapper
             Object value = null;
 
             while (e.hasMoreElements()) {
-                key = (String) e.nextElement();
+                key = e.nextElement();
                 value = ht.get(key);
                 byte data[] = null;
 
@@ -517,9 +519,9 @@ class RequestAttrsMapper
         return is.readObject();
     }
 
-    private Hashtable decodeHashtable(byte[] data)
+    private Hashtable<String, Object> decodeHashtable(byte[] data)
             throws ObjectStreamException, IOException, ClassNotFoundException {
-        Hashtable ht = new Hashtable();
+        Hashtable<String, Object> ht = new Hashtable<String, Object>();
         ByteArrayInputStream bis = new ByteArrayInputStream(data);
         ObjectInputStream is = new ObjectInputStream(bis);
 
@@ -561,7 +563,7 @@ class RequestAttrsMapper
     public void mapLDAPAttributeSetToObject(LDAPAttributeSet attrs,
             String name, IDBObj parent)
             throws EBaseException {
-        Hashtable ht = null;
+        Hashtable<String, Object> ht = null;
 
         //
         // Data is stored in a (single valued) binary attribute
@@ -574,7 +576,8 @@ class RequestAttrsMapper
             attr = attrs.getAttribute(Schema.LDAP_ATTR_REQUEST_ATTRS);
 
             if (attr != null) {
-                Enumeration values = attr.getByteValues();
+                @SuppressWarnings("unchecked")
+                Enumeration<byte[]> values = attr.getByteValues();
 
                 value = (byte[]) values.nextElement();
 
@@ -596,7 +599,7 @@ class RequestAttrsMapper
         return Schema.LDAP_ATTR_REQUEST_ID + op + value;
     }
 
-    protected final static Vector mAttrs = new Vector();
+    protected final static Vector<String> mAttrs = new Vector<String>();
 
     static {
         mAttrs.add(Schema.LDAP_ATTR_REQUEST_ATTRS);
@@ -774,12 +777,13 @@ class ExtAttrDynMapper implements IDBDynAttrMapper {
     public void mapObjectToLDAPAttributeSet(IDBObj parent, String name,
                                             Object obj, LDAPAttributeSet attrs)
             throws EBaseException {
-        Hashtable ht = (Hashtable) obj;
-        Enumeration e = ht.keys();
+        @SuppressWarnings("unchecked")
+        Hashtable<String, Object> ht = (Hashtable<String, Object>) obj;
+        Enumeration<String> e = ht.keys();
 
         try {
             while (e.hasMoreElements()) {
-                String key = (String) e.nextElement();
+                String key = e.nextElement();
                 Object value = ht.get(key);
                 if (value instanceof String) {
                     String stringValue = (String) value;
@@ -787,11 +791,12 @@ class ExtAttrDynMapper implements IDBDynAttrMapper {
                             extAttrPrefix + encodeKey(key),
                             stringValue));
                 } else if (value instanceof Hashtable) {
-                    Hashtable innerHash = (Hashtable) value;
-                    Enumeration innerHashEnum = innerHash.keys();
+                    @SuppressWarnings("unchecked")
+                    Hashtable<String, String> innerHash = (Hashtable<String, String>) value;
+                    Enumeration<String> innerHashEnum = innerHash.keys();
                     while (innerHashEnum.hasMoreElements()) {
-                        String innerKey = (String) innerHashEnum.nextElement();
-                        String innerValue = (String) innerHash.get(innerKey);
+                        String innerKey = innerHashEnum.nextElement();
+                        String innerValue = innerHash.get(innerKey);
                         attrs.add(new LDAPAttribute(
                                 extAttrPrefix + encodeKey(key) + ";" + encodeKey(innerKey),
                                 innerValue));
@@ -807,15 +812,16 @@ class ExtAttrDynMapper implements IDBDynAttrMapper {
         }
     }
 
+    @SuppressWarnings("unchecked")
     public void mapLDAPAttributeSetToObject(LDAPAttributeSet attrs, String name,
                                             IDBObj parent)
             throws EBaseException {
-        Hashtable ht = new Hashtable();
-        Hashtable valueHashtable;
+        Hashtable<String, Object> ht = new Hashtable<String, Object>();
+        Hashtable<String, String> valueHashtable;
 
-        Enumeration attrEnum = attrs.getAttributes();
+        Enumeration<LDAPAttribute> attrEnum = attrs.getAttributes();
         while (attrEnum.hasMoreElements()) {
-            LDAPAttribute attr = (LDAPAttribute) attrEnum.nextElement();
+            LDAPAttribute attr = attrEnum.nextElement();
             String baseName = attr.getBaseName();
             if (baseName.toLowerCase().startsWith(extAttrPrefix)) {
                 String keyName = decodeKey(
@@ -848,9 +854,9 @@ class ExtAttrDynMapper implements IDBDynAttrMapper {
                         Debug.trace(message);
                         throw new EBaseException(message);
                     }
-                    valueHashtable = (Hashtable) value;
+                    valueHashtable = (Hashtable<String, String>) value;
                     if (valueHashtable == null) {
-                        valueHashtable = new Hashtable();
+                        valueHashtable = new Hashtable<String, String>();
                         ht.put(keyName, valueHashtable);
                     }
                     valueHashtable.put(decodeKey(subTypes[0]), values[0]);
diff --git a/pki/base/common/src/com/netscape/cmscore/usrgrp/User.java b/pki/base/common/src/com/netscape/cmscore/usrgrp/User.java
index e48b8fcb4d5bd201ee2da345a2728bb6cf53f05f..89ea3e589754563b9d1686d2cbfd8f7bd556990e 100644
--- a/pki/base/common/src/com/netscape/cmscore/usrgrp/User.java
+++ b/pki/base/common/src/com/netscape/cmscore/usrgrp/User.java
@@ -51,7 +51,7 @@ public class User implements IUser {
     private String mUserType = null;
     private X509Certificate mx509Certs[] = null;
 
-    private static final Vector mNames = new Vector();
+    private static final Vector<String> mNames = new Vector<String>();
     static {
         mNames.addElement(ATTR_NAME);
         mNames.addElement(ATTR_ID);
@@ -212,7 +212,7 @@ public class User implements IUser {
         throw new EBaseException(CMS.getUserMessage("CMS_BASE_INVALID_ATTRIBUTE", name));
     }
 
-    public Enumeration getElements() {
+    public Enumeration<String> getElements() {
         return mNames.elements();
     }
 }
diff --git a/pki/base/common/src/com/netscape/cmscore/util/Debug.java b/pki/base/common/src/com/netscape/cmscore/util/Debug.java
index 9d8b33d66946318b2b7e0805e5d7d54c55f089a4..66e316c11d9eefcafcb89765f0d573196251c93e 100644
--- a/pki/base/common/src/com/netscape/cmscore/util/Debug.java
+++ b/pki/base/common/src/com/netscape/cmscore/util/Debug.java
@@ -70,7 +70,7 @@ public class Debug
     private static int mDebugLevel = VERBOSE;
 
     private static PrintStream mOut = null;
-    private static Hashtable mHK = null;
+    private static Hashtable<String, String> mHK = null;
 
     static {
         if (TRACE_ON == true) {
@@ -348,7 +348,7 @@ public class Debug
                 if (hashkeytypes != null) {
                     StringTokenizer st = new StringTokenizer(hashkeytypes,
                             ",", false);
-                    mHK = new Hashtable();
+                    mHK = new Hashtable<String, String>();
                     while (st.hasMoreElements()) {
                         String hkr = st.nextToken();
                         mHK.put(hkr, "true");
diff --git a/pki/base/common/test/com/netscape/cmscore/request/RequestQueueTest.java b/pki/base/common/test/com/netscape/cmscore/request/RequestQueueTest.java
index d69ac6a5339a6f3e7416e9d8c78334ab62106012..a66326d0349e965382e24211ba6b77173ada9a79 100644
--- a/pki/base/common/test/com/netscape/cmscore/request/RequestQueueTest.java
+++ b/pki/base/common/test/com/netscape/cmscore/request/RequestQueueTest.java
@@ -44,7 +44,7 @@ public class RequestQueueTest extends CMSBaseTestCase {
         String[] keys = new String[] { "key1", "key2" };
         boolean getExtDataKeysCalled = false;
 
-        public Enumeration getExtDataKeys() {
+        public Enumeration<String> getExtDataKeys() {
             getExtDataKeysCalled = true;
             return Collections.enumeration(Arrays.asList(keys));
         }
diff --git a/pki/base/common/test/com/netscape/cmscore/request/RequestRecordTest.java b/pki/base/common/test/com/netscape/cmscore/request/RequestRecordTest.java
index 457f91d9bd730c073c8ede6a4edef9c083396f40..06a4725716cdc35cc6bde14418e796fb0395f30e 100644
--- a/pki/base/common/test/com/netscape/cmscore/request/RequestRecordTest.java
+++ b/pki/base/common/test/com/netscape/cmscore/request/RequestRecordTest.java
@@ -40,7 +40,7 @@ public class RequestRecordTest extends CMSBaseTestCase {
     }
 
     public void testGetExtData() {
-        Hashtable hash = new Hashtable();
+        Hashtable<String, Object> hash = new Hashtable<String, Object>();
 
         assertNotSame(hash, requestRecord.get(IRequestRecord.ATTR_EXT_DATA));
         requestRecord.mExtData = hash;
@@ -48,7 +48,7 @@ public class RequestRecordTest extends CMSBaseTestCase {
     }
 
     public void testSetExtData() {
-        Hashtable hash = new Hashtable();
+        Hashtable<String, Object> hash = new Hashtable<String, Object>();
 
         assertNotSame(requestRecord.mExtData, hash);
         requestRecord.set(IRequestRecord.ATTR_EXT_DATA, hash);
diff --git a/pki/base/common/test/com/netscape/cmscore/test/TestHelper.java b/pki/base/common/test/com/netscape/cmscore/test/TestHelper.java
index cc19d8abaeac0d66ac5b9584bfd015d5d8024483..55d2ac7f7a6722556a741733cd9541358f7359ba 100644
--- a/pki/base/common/test/com/netscape/cmscore/test/TestHelper.java
+++ b/pki/base/common/test/com/netscape/cmscore/test/TestHelper.java
@@ -7,7 +7,7 @@ import java.util.Enumeration;
  */
 public class TestHelper {
 
-    public static boolean enumerationContains(Enumeration enumeration,
+    public static boolean enumerationContains(Enumeration<?> enumeration,
                                               Object element) {
         while (enumeration.hasMoreElements()) {
             if (enumeration.nextElement().equals(element)) {
diff --git a/pki/base/java-tools/src/com/netscape/cmstools/TokenInfo.java b/pki/base/java-tools/src/com/netscape/cmstools/TokenInfo.java
index d695dcfa7e3bc4eb39c4c7ac9a482bf529f97d91..fc3d13b42a947ee2d41587590dff801338ed21b0 100644
--- a/pki/base/java-tools/src/com/netscape/cmstools/TokenInfo.java
+++ b/pki/base/java-tools/src/com/netscape/cmstools/TokenInfo.java
@@ -52,15 +52,17 @@ public class TokenInfo {
             CryptoManager.initialize(vals);
 
             CryptoManager cm = CryptoManager.getInstance();
-            Enumeration modules = cm.getModules();
+            @SuppressWarnings("unchecked")
+            Enumeration<PK11Module> modules = cm.getModules();
             while (modules.hasMoreElements()) {
-                PK11Module m = (PK11Module) modules.nextElement();
+                PK11Module m = modules.nextElement();
                 System.out.println("Found external module '" + m.getName() + "'");
             }
-            Enumeration tokens = cm.getExternalTokens();
+            @SuppressWarnings("unchecked")
+            Enumeration<CryptoToken> tokens = cm.getExternalTokens();
 
             while (tokens.hasMoreElements()) {
-                CryptoToken t = (CryptoToken) tokens.nextElement();
+                CryptoToken t = tokens.nextElement();
                 System.out.println("Found external token '" + t.getName() + "'");
             }
 
diff --git a/pki/base/kra/src/com/netscape/kra/StorageKeyUnit.java b/pki/base/kra/src/com/netscape/kra/StorageKeyUnit.java
index 87559163c9fdec4c152d448bfac9bd7de614bdec..3c61c293bef26484d40596171f0b293467e1ec2c 100644
--- a/pki/base/kra/src/com/netscape/kra/StorageKeyUnit.java
+++ b/pki/base/kra/src/com/netscape/kra/StorageKeyUnit.java
@@ -517,8 +517,8 @@ public class StorageKeyUnit extends EncryptionUnit implements
     /**
      * Returns a list of recovery agent identifiers.
      */
-    public Enumeration getAgentIdentifiers() {
-        Vector v = new Vector();
+    public Enumeration<String> getAgentIdentifiers() {
+        Vector<String> v = new Vector<String>();
 
         for (int i = 0;; i++) {
             try {
@@ -884,7 +884,7 @@ public class StorageKeyUnit extends EncryptionUnit implements
             throws EBaseException {
         // sort the credential according to the order in
         // configuration file
-        Hashtable v = new Hashtable();
+        Hashtable<String, byte[]> v = new Hashtable<String, byte[]>();
 
         for (int i = 0;; i++) {
             String uid = null;
@@ -938,10 +938,10 @@ public class StorageKeyUnit extends EncryptionUnit implements
             CMS.debug("Failed to initialize JoinShares");
             throw new EBaseException(CMS.getUserMessage("CMS_AUTHENTICATION_INVALID_CREDENTIAL"));
         }
-        Enumeration e = v.keys();
+        Enumeration<String> e = v.keys();
 
         while (e.hasMoreElements()) {
-            String next = (String) e.nextElement();
+            String next = e.nextElement();
 
             j.addShare(Integer.parseInt(next) + 1,
                     (byte[]) v.get(next));
diff --git a/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordFile.java b/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordFile.java
index c962e1c6eaa3a976cc2c263ef4791e3c9ed7e3b0..91a45ca3bce9fdedd62c803287a5bf5cd5c70b58 100644
--- a/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordFile.java
+++ b/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordFile.java
@@ -47,7 +47,7 @@ public class PlainPasswordFile implements IPasswordStore {
     }
 
     // return an array of String-based tag
-    public Enumeration getTags() {
+    public Enumeration<?> getTags() {
         return mPwdStore.propertyNames();
     }
 
diff --git a/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordReader.java b/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordReader.java
index 4065fd72c109bbb00622d3e78494c7779e57e8d0..10f33350c615feda77520337fa51e19866c5075b 100644
--- a/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordReader.java
+++ b/pki/base/util/src/com/netscape/cmsutil/password/PlainPasswordReader.java
@@ -46,7 +46,7 @@ public class PlainPasswordReader implements IPasswordReader {
     }
 
     // return an array of String-based tag
-    public Enumeration getTags() {
+    public Enumeration<?> getTags() {
         return mPwdStore.propertyNames();
     }
 }
diff --git a/pki/base/util/src/netscape/security/provider/DSAKeyPairGenerator.java b/pki/base/util/src/netscape/security/provider/DSAKeyPairGenerator.java
index a56839ac189648e9092e8592bd4ee3874920caaf..3e04792bf8b58fb23ba1381d6ef113ec51a557bd 100644
--- a/pki/base/util/src/netscape/security/provider/DSAKeyPairGenerator.java
+++ b/pki/base/util/src/netscape/security/provider/DSAKeyPairGenerator.java
@@ -49,7 +49,7 @@ import netscape.security.x509.AlgIdDSA;
 public class DSAKeyPairGenerator extends KeyPairGenerator
         implements java.security.interfaces.DSAKeyPairGenerator {
 
-    private static Hashtable precomputedParams;
+    private static Hashtable<Integer, AlgIdDSA> precomputedParams;
 
     static {
 
@@ -63,7 +63,7 @@ public class DSAKeyPairGenerator extends KeyPairGenerator
            hash.  
            */
 
-        precomputedParams = new Hashtable();
+        precomputedParams = new Hashtable<Integer, AlgIdDSA>();
 
         /*
          * L = 512
@@ -182,7 +182,7 @@ public class DSAKeyPairGenerator extends KeyPairGenerator
         /* Find the precomputed parameters, if any */
         if (!generateNewParameters) {
             Integer mod = Integer.valueOf(this.modlen);
-            params = (DSAParams) precomputedParams.get(mod);
+            params = precomputedParams.get(mod);
         }
         if (params != null) {
             setParams(params);
-- 
1.7.7.4

